Loading...
Searching...
No Matches
perfmodel.h File Reference
`#include <common/config.h>`
`#include <starpu.h>`
`#include <core/task_bundle.h>`
`#include <stdio.h>`

Go to the source code of this file.

## Data Structures

struct | _starpu_perfmodel_state

## Macros

#define | _STARPU_PERFMODEL_VERSION
#define | PATH_LENGTH
#define | STR_SHORT_LENGTH
#define | STR_LONG_LENGTH
#define | STR_VERY_LONG_LENGTH

## Functions

void | _starpu_init_perfmodel (void)
void | _starpu_find_perf_model_codelet (const char *symbol, const char *hostname, char *path, size_t maxlen)
void | _starpu_find_perf_model_codelet_debug (const char *symbol, const char *hostname, const char *arch, char *path, size_t maxlen)
void | _starpu_set_default_perf_model_codelet (const char *symbol, const char *hostname, char *path, size_t maxlen)
char * | _starpu_get_perf_model_dir_default ()
char ** | _starpu_get_perf_model_dirs_codelet () STARPU_ATTRIBUTE_VISIBILITY_DEFAULT
char * | _starpu_get_perf_model_dir_bus ()
double | _starpu_history_based_job_expected_perf (struct starpu_perfmodel *model, struct starpu_perfmodel_arch *arch, struct _starpu_job *j, unsigned nimpl)
double | _starpu_history_based_job_expected_deviation (struct starpu_perfmodel *model, struct starpu_perfmodel_arch *arch, struct _starpu_job *j, unsigned nimpl)
void | _starpu_load_history_based_model (struct starpu_perfmodel *model, unsigned scan_history)
void | _starpu_init_and_load_perfmodel (struct starpu_perfmodel *model)
void | _starpu_initialize_registered_performance_models (void)
void | _starpu_deinitialize_registered_performance_models (void)
void | _starpu_deinitialize_performance_model (struct starpu_perfmodel *model)
double | _starpu_regression_based_job_expected_perf (struct starpu_perfmodel *model, struct starpu_perfmodel_arch *arch, struct _starpu_job *j, unsigned nimpl)
double | _starpu_non_linear_regression_based_job_expected_perf (struct starpu_perfmodel *model, struct starpu_perfmodel_arch *arch, struct _starpu_job *j, unsigned nimpl)
double | _starpu_multiple_regression_based_job_expected_perf (struct starpu_perfmodel *model, struct starpu_perfmodel_arch *arch, struct _starpu_job *j, unsigned nimpl)
void | _starpu_update_perfmodel_history (struct _starpu_job *j, struct starpu_perfmodel *model, struct starpu_perfmodel_arch *arch, unsigned cpuid, double measured, unsigned nimpl, unsigned number)
int | _starpu_perfmodel_create_comb_if_needed (struct starpu_perfmodel_arch *arch)
int | _starpu_create_bus_sampling_directory_if_needed (int location)
void | _starpu_create_codelet_sampling_directory_if_needed (int location)
void | _starpu_load_bus_performance_files (void)
void | _starpu_init_bus_performance (void)
int | _starpu_get_perf_model_bus ()
int | _starpu_set_default_perf_model_bus ()
void | _starpu_set_calibrate_flag (unsigned val)
unsigned | _starpu_get_calibrate_flag (void)
unsigned * | _starpu_get_cuda_affinity_vector (unsigned gpuid)
unsigned * | _starpu_get_opencl_affinity_vector (unsigned gpuid)
void | _starpu_save_bandwidth_and_latency_disk (double bandwidth_write, double bandwidth_read, double latency_write, double latency_read, unsigned node, const char *name)
void | _starpu_write_double (FILE *f, const char *format, double val) STARPU_ATTRIBUTE_VISIBILITY_DEFAULT
int | _starpu_read_double (FILE *f, char *format, double *val) STARPU_ATTRIBUTE_VISIBILITY_DEFAULT
void | _starpu_simgrid_get_platform_path (int version, char *path, size_t maxlen)
void | _starpu_perfmodel_realloc (struct starpu_perfmodel *model, int nb)
void | _starpu_free_arch_combs (void)
hwloc_topology_t | _starpu_perfmodel_get_hwtopology ()

## Variables

unsigned | _starpu_calibration_minimum

## Data Structure Documentation

## _starpu_perfmodel_state

struct _starpu_perfmodel_state

Data Fields
struct starpu_perfmodel_per_arch ** | per_arch |
int ** | per_arch_is_set |
starpu_pthread_rwlock_t | model_rwlock |
int * | nimpls |
int * | nimpls_set |
int | ncombs | The number of combinations currently used by the model
int | ncombs_set | The number of combinations allocated in the array nimpls and ncombs
int * | combs |

## Macro Definition Documentation

## _STARPU_PERFMODEL_VERSION

#define _STARPU_PERFMODEL_VERSION

Performance models files are stored in a directory whose name include the version of the performance model format. The version number is also written in the file itself. When updating the format, the variable _STARPU_PERFMODEL_VERSION should be updated. It is then possible to switch easily between different versions of StarPU having different performance model formats.